<template>
        <div class="header-nav-wrap">
            <div :class="['header-nav', { 'header-nav--active': visibleMenu }]">
                <div class="header-nav__hamburger" @click="changeVisibleMenu">
                    <base-svg-icon id="hamburger" width="42" height="40" viewBox="0 0 42 40" />
                </div>
                <div :class="['header-nav__content', { 'header-nav__content--active': visibleMenu }]">
                    <!-- Desktop menu start -->
                    <div v-if="!onMobileMenu" class="header-nav__list">
                        <router-link to='/ois' class="header-nav__link">
                            <div class="header-nav__text">Мои оис</div>
                        </router-link>
                        <router-link to='/favorites' class="header-nav__link">
                            <div class="header-nav__text">Избранное <span v-if="favorites" class="header-nav__text-favorites">{{ favorites }}</span></div>
                        </router-link>
                        <div class="header-nav__link header-nav__link--grouping" @click="changeVisibleMenu">
                            <div class="header-nav__text header-nav__text--login-name">{{ accountName }}</div>
                            <div v-show="visibleMenu" class="header-nav__grouping">
                                <div class="header-nav__grouping-item">
                                    <base-router-link-id-front to='profile' class="header-nav__link">
                                        <div class="header-nav__text">Профиль</div>
                                    </base-router-link-id-front>
                                    <base-router-link-id-front to='profile/settings' class="header-nav__link">
                                        <div class="header-nav__text">Настройки</div>
                                    </base-router-link-id-front>
                                    <div class="header-nav__link">
                                        <div class="header-nav__text" @click="logoutUser">Выход</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Desktop menu end -->
                    <!-- Mobile menu start -->
                    <div v-if="onMobileMenu" v-show="visibleMenu" class="header-nav__grouping-list">
                        <div class="header-nav__grouping-list-content">
                            <div class="header-nav__grouping-item">
                                <router-link to='/ois' class="header-nav__link">
                                    <div class="header-nav__text">Мои оис</div>
                                </router-link>
                                <router-link to='/favorites' class="header-nav__link">
                                    <div class="header-nav__text">Избранное <span v-if="favorites" class="header-nav__text-favorites">{{ favorites }}</span></div>
                                </router-link>
                                <base-router-link-id-front to='profile' class="header-nav__link">
                                    <div class="header-nav__text">Профиль</div>
                                </base-router-link-id-front>
                                <base-router-link-id-front to='profile/settings' class="header-nav__link">
                                    <div class="header-nav__text">Настройки</div>
                                </base-router-link-id-front>
                                <div class="header-nav__link" @click="logoutUser">
                                    <div class="header-nav__text">Выход</div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- Mobile menu end -->
                </div>
            </div>
        </div>
</template>

<script>
export default {
    name: 'header-nav',
    data() {
        return {
            visibleMenu: false
        };
    },
    computed: {
        screenWidth() {
            return this.getValueByProperty('width');
        },
        onMobileMenu() {
            return this.screenWidth < 768;
        },
        accountName() {
            return this.user.email || this.user.phone || 'anonymous';
        },
        ...mapState('account', ['isAuthorized', 'user', 'favorites']),
        ...mapGetters('information', ['getValueByProperty'])
    },
    methods: {
        changeVisibleMenu() {
            this.visibleMenu = !this.visibleMenu;
        },
        logoutUser() {
            this.logout().then(() => {
                window.location.href = process.env.VUE_APP_URL_PROJECT_ID + 'login';
            });
        },
        ...mapActions('account', ['logout'])
    }
};
</script>

<style lang="sass">
    @import '~blocks/header-nav';
</style>
